"""
========================================
  Introduction to Computer Programming
========================================

-----------------------------------------------
  Lab 5
  REPLs

  (starter file - remove this line once edited)
  <YOUR NAMES GO HERE>
-----------------------------------------------
"""


# from ... import ...


# 0. warmup: use int, input, print with f string
def days_to_hours():
    """
    Asks the user to enter a number of days and responds by printing the number
    of hours equivalent to that many days as in:

        Enter a number of days: 7
        There are 168 hours in 7 days.
    """
    ...


# 1. very similar to example has_any
#    second argument is a function
def every(s, property):
    """
    Returns True if property (a function that takes as input a string and
    returns a Boolean value) is True for every character that occurs in string
    s, False otherwise. Returns True if s is empty.

    >>> every('C3P0', is_digit)
    False
    >>> every('SHHH', is_upper)
    True
    """
    b = True
    ...
    return b


# 2. basic REPL (no need to call other function than len, print/input)
#    choose values that define medium length
def get_medium_string():
    """
    Repeatedly ask the user to enter strings that are of medium length. If they
    are too short or too long, the program responds that way and asks them to
    try again. Once a medium-length string is entered it is returned. Example:

        Enter a medium-length string: no
        "no" is too short. Try again.
        Enter a medium-length string: whatever
        "whatever" is too long. Try again.
        Enter a medium-length string: middle

        (returns 'middle')
    """
    t = ''
    while ...:
        t = input('Enter a medium-length string: ')
        ...
    return t


# 3. basic REPL (no need to call other function than print/input)
#    makes use of None
def yorn(prompt):
    """
    Repeatedly display the prompt to the user as part of asking them to enter
    'Y' or 'N' (to indicate yes or no). If user enters 'y' (lower or upper),
    returns True. If user enters 'n' (lower or upper), returns False. Otherwise
    repeats. For example: yorn('Do you want to play again?') might result in:

        Do you want to play again? (enter Y or N) whatever
        Invalid response: "whatever". Try again.
        Do you want to play again? (enter Y or N) n

        (returns False)
    """
    yn = None
    while yn is None:
        ...
    return yn


# 4. use definite loop, print
def show_sequence(f, n, i):
    """
    Computes and prints sequence of n numbers i, f(i), f(f(i)) and so on.
    Returns f applied one more time to that final number. Assumes f is a
    function that takes as input a positive integer and returns a positive
    integer and that n and i are positive integers. For example, if double is a
    function that returns twice its input, then evaluating:

        show_sequence(double, 5, 1)

    should print:

        1
        2
        4
        8
        16

    and return 32.
    """
    ...
    for _ in ...:
        ...
    return ...


# 5. calls show_sequence; call every to verify string input is all numbers
#    before converting to an integer using int
def quizzer(f):
    """
    REPL to play a simple quiz game: the user is shown a random number between
    1 and 9 (inclusive) and the value of f applied three times successively to
    that number. The user is then repeatedly asked to enter the result of the
    next application of f until they enter an incorrect value. Returns the
    number of correct responses or None if the user chooses to quit (by
    entering 'quit' when asked to enter a number). Examples:

        quizzer(double) might result in:

        The first few numbers are:

        2
        4
        8

        What is next after 16? 32
        Correct!
        What is next after 32? 65
        Wrong!
        Game over after 1 correct answers.

        (returns 1)

        quizzer(add1) might result in:

        The first few numbers are:

        3
        4
        5

        What is next after 6? 7
        Correct!
        What is next after 7? boring!
        "boring!" is not a valid response.
        What is next after 7? quit
        Quitters never learn.
        Game over after 1 correct answers.

        (returns None)
    """
    print('The first few numbers are:\n')
    x = 1   # ... use randrange ...
    x = show_sequence(f, 3, x)
    g = None
    score = 0
    while g is None or g == x:
        ...
    return score


# 6. create as many functions as you like
#    function should choose from at least 3
def function_selector():
    """
    Randomly selects and returns one of several functions each of which operate
    on integers.
    """
    r = 0   # ... use randrange ...
    if r == 0:
        f = add1   # ... change this ...
    # add cases ...
    return f


# 7. calls quizzer, function_selector, yorn
def repeat_quiz():
    """
    Repeatedly plays quizzer game using random selected function until player
    chooses not play again. Reports number of completed games and total score.
    """
    count = 0
    score = 0
    while True:
        ...
    print(f'You completed {count} games for a total of {score} points.')


# ----- below this line are familiar functions supplied for your use -----


def is_digit(ch):
    b = len(ch) == 1 and '0' <= ch and ch <= '9'
    return b


def is_upper(ch):
    b = len(ch) == 1 and 'A' <= ch and ch <= 'Z'
    return b


def add1(x):
    y = x + 1
    return y


def double(x):
    y = x + x
    return y


def square(x):
    y = x * x
    return y


def ulam(m):
    if m % 2 == 0:
        n = m // 2
    else:
        n = 3*m + 1
    return n
